# CreateProj

[![Gem Version](https://badge.fury.io/rb/createproj.svg)](http://badge.fury.io/rb/createproj)
[![Build Status](https://travis-ci.org/mattjmcnaughton/createproj.svg?branch=master)](https://travis-ci.org/mattjmcnaughton/createproj)
[![Code Climate](https://codeclimate.com/github/mattjmcnaughton/createproj/badges/gpa.svg)](https://codeclimate.com/github/mattjmcnaughton/createproj)
[![Coverage Status](https://img.shields.io/coveralls/mattjmcnaughton/createproj.svg)](https://coveralls.io/r/mattjmcnaughton/createproj)

## Description
Quickly create a new project with git respotitory, post commit hooks, and dependencies indended to be included for all projects.

Read more on my [blog](http://mattjmcnaughton.com/createproject).

## Usage

Download the gem with `gem install createproj`

To create proj, run `createproj [ruby|haskell] PROJ_NAME` in the directory you want your project created.

Remember, as of now, createproj assumes that you have both rvm and cabal installed.

Once run, createproj will:
- Create the project directory
- Initialize a git repository with a language specified .gitignore and language specified git pre-commit hook (right now both are linters)
- Create a sandbox
    - Ruby, Rails: rvm gemset
    - Haskell: cabal sandbox
    - Python: virtualenv environment
- Install default dependencies in the sandbox
    - Ruby, Rails: rubocop, yard, rspec
    - Haskell: happy, hlint
    - Python: pylint,

## Options
For a variety of projects options can be set through the command line.
- Rails
    - `-d, --database, the desired rails database`

## Steps for building/publish gem
- From `createproj` directory, run:
    - `rake gem:build` to build the gem
    - `rake gem:publish` to publish the gem

## Development
- Code is linted using rubocop
- Code is documented using Yardoc

## Dependencies
For each language, I assume certain dependencies:
- Ruby
    - [Rvm](https://rvm.io/)
- Haskell
    - [Cabal](https://www.haskell.org/cabal/)
- Python
    - [virtualenv](https://virtualenv.pypa.io/en/latest/), [virtualenvwrapper](http://virtualenvwrapper.readthedocs.org/en/latest/index.html)
        - I also assume that [this](https://gist.github.com/mattjmcnaughton/4d599b62b60b59f9229f) virtualenv script is sourced. If not, instructions will be given to install.

## Contributing
Please do! Let me know if I can be of any help!


